/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $filter="Фильтр";
  var $filter_empty="Нет объектов, удовлетворяющих фильтру";
  var $count_filter="Фильтр";
  var $noobjects="Нет объектов";
  var $objects="Объекты";
}else{
  var $filter="Filter";
  var $filter_empty="No objects matching the filter";
  var $count_filter="Filter";
  var $noobjects="No objects";
  var $objects="Objects";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`a-browser-item{--icon-hover-color:var(--app-active-text-color);--text-hover-color:var(--app-active-text-color)}`,
	`<div id="pult_header">
	<div class="pult_split">
		<a-input clear_button=1 debounce=300 placeholder=${$filter} id='filter'></a-input>
	</div>
</div>
<a-browser id='browser' empty_string="${$noobjects}"></a-browser>
<div id='empty' class="pult_empty" hidden>${$filter_empty}</div>
`,
);

PROPERTIES={
	filter:{
		type:'string',
	},
};


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let paths={};

function create(){
	dom.filter.onchange=function(e){
		self.filter=e.detail;
    }
	pult.events.listen('user_alarms',update_user_alarms);
	pult.metronom.listen(onMetronom,5);
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
	pult.events.unlisten('user_alarms',update_user_alarms);
	pult.metronom.unlisten(onMetronom,5);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
		if(k==='filter')	update_filter(changes[k]);
	}
}


function update_filter(){

	let brw=dom.browser;
    let f=self.__filter;
    dom.filter.value=f;
    
    let count=0;
    let visible=0;
    
    for(let n of brw.childNodes){
        count++;
        if(Util.match(f,n.title)){
            n.hidden=false;
            visible++;
        }else{
            n.hidden=true;
        }
    }

    if(count>0 && visible==0){
		dom.browser.hidden=true;
        dom.empty.hidden=false;
    }else{
		dom.browser.hidden=false;
        dom.empty.hidden=true;
    }

    if(f){
        pult.showCount(self,visible,$count_filter);
    }else{
        pult.showCount(self,visible);
    }
}


function update_path(path){

	//self.clear();

	
	pult.showLoading(self);
	pult.unsubscribeStatusVar(self);

	pult.loadObject(self,{
		path:path,
		docs:'@prop.json',
		unpack:'@prop.json',
		parent:true,
		cache:true,
		children:true,
		interface:true,
		inactive:false,
		access:pult.ACS_TYPE_EDIT,
	},function (o){
		pult.hideLoading(self);
		pult.showObjectPath(self,o);
		pult.selectMenuItem(self,path);
		pult.showHeader(self,o.show_header);
		pult.showEditorLink(self,o);
		pult.showAlarms(self,!o.hide_alarm_panel && !!o._alarms);
		
		pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v;});

		let p=o._parent;
		if(p._type==='project'){
			pult.showName(self,p._title,p._icon);
			pult.showCaption(self,o._title);
		}else{
			pult.showName(self,o._title,o._icon);
			let ct=schema.types.common;
			let st=schema.types[o._type];
			pult.showCaption(self,st.objects_title ?? ct.objects_title);
		}

		let sv=[];
		for(let i=0; i<o._children?.length; i++){
			let ch=o._children[i];
			if(ch._status_var) sv.push([ch._status_var,i]);
		}

		let brw=dom.browser;
		pult.subscribeStatusVar(self,sv,function (v,i){
			let bi=brw.children[i];
			if(bi){
				let status=pult.nodeStatuses[v];
				if(status){
					bi.style.setProperty('--text-color',status.color);
					bi.style.setProperty('--icon-color',status.color);
				}else{
					bi.style.setProperty('--text-color','');
					bi.style.setProperty('--icon-color','');
				}
				// bi.classList.toggle('online',v!==0);
				// bi.classList.toggle('offline',v===0);
			}
		});

		drawList(o._children);
		

	});
}

function drawList(list){
	let brw=dom.browser;
	brw.innerHTML='';

	paths={};

	if(list){
		for(let i=0; i<list.length; i++){
			let o=list[i];
			if(o){
				let bi=Util.create(brw,{
					tag:"a-browser-item",
					title:o._title,
					icon_size:32,
					href:o._interface,
					icon_src:o._icon,
				});
				paths[o._path]=bi;
			}
		}	
	}
	update_filter();
	updateBages(paths);

}

function update_user_alarms(){
	updateBages(pult.userAlarms.changes);
}


function onMetronom(m){
	
	let upd;
	if(m){
		upd={};
		for(let k in paths){
			let o=pult.userAlarms?.objects[k];
			if(o  && o.au[0]){
				upd[k]=o;
			}
		}
	}else{
		upd={};
		for(let k in paths){
			let o=pult.userAlarms?.objects[k];
			if(o && o.au[0]){
				upd[k]={
					au:[0,0],
					aa:[0,0],
					iu:[0,0],
				}
			}
		}
	}
	updateBages(upd,upd);

}

function updateBages(keys,objects){
		
	if(!objects) objects=pult.userAlarms.objects;

	for(let k in keys){
		let bi=paths[k];
		if(bi){
			let o=objects[k];
			if(o){
				let s=o.au[0]+o.aa[0]+o.iu[0];
				if(s){

					let cls=0;
					if(cls < o.iu[1]) cls=o.iu[1];
					if(cls < o.aa[1]) cls=o.aa[1];
					if(cls < o.au[1]) cls=o.au[1];

					let clr;
					if(cls===4) clr='var(--app-alm-alarm-text-color)';
					if(cls===3) clr='var(--app-alm-fault-text-color)';
					if(cls===2) clr='var(--app-alm-warning-text-color)';
					if(cls===1) clr='var(--app-alm-notice-text-color)';
					if(cls===0) clr='var(--app-alm-info-text-color)';

					bi.showBadge(clr,clr);
					// if(o.au[0]){
					// }else if(o.aa[0]){
					// 	bi.showBadge(clr,clr);
					// }else{
					// 	bi.showBadge(undefined,brd);
					// }
				}else{
					bi.hideBadge(k);
				}
			}else{
				bi.hideBadge(k);
			}
		}
	}

}