/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Настройки";
  var $control_service="Управление сервисом";
  var $error="Ошибка";
  var $status_running="Запущен";
  var $status_stopped="Остановлен";
  var $status_disabled="Отключен";
  var $main_settings="Основные настройки";
  var $advanced_settings="Дополнительные настройки";
  var $save="Сохранить";
  var $cancel="Отменить";
  

}else{
  var $title="Settings";
  var $control_service="Control service";
  var $error="Error";
  var $status_running="Running";
  var $status_stopped="Stopped";
  var $status_disabled="Disabled";
  var $main_settings="Main settings";
  var $advanced_settings="Advanced settings";
  var $save="Save";
  var $cancel="Cancel";
  
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#header{padding:20px;display:flex;flex-direction:row;justify-content:space-between;border-bottom:solid 1px var(--app-form-color)}#header>div:first-child{max-width:500px}#title{display:flex;flex-direction:row;align-items:center}#title>*{display:block}#title.running #icon{--color:var(--app-online-color)}#title.running #name{color:var(--app-online-color)}#title.error #icon{--color:var(--app-error-color)}#title.error #name{color:var(--app-error-color)}#icon{margin-right:10px;width:32px;height:32px;--color:var(--app-comment-color)}#name{font-size:24px;color:var(--app-comment-color)}#help{margin-top:10px;color:var(--app-comment-color)}#config{border-top:solid 1px var(--app-form-color);padding:20px}#control{margin-top:10px;white-space:nowrap}#control>a>*{vertical-align:text-top}#status{margin-top:10px}.pult_header>.pult_split{border-left:none!important}#form{padding:0}#form .confhead{padding:30px 20px 10px;font-size:14px;background-color:var(--app-section-header-color);color:var(--app-section-header-text-color);text-transform:uppercase}#form a-form-row{border-bottom:solid 1px var(--app-form-color);padding-top:10px;padding-bottom:10px;--caption-font-weight:bold;--comment-color:var(--app-comment-color);--comment-padding:10px 0 0 0}#form a-label{--text-color:var(--app-comment-color)}`,
	`
<div id="pult_header">
	<div class="pult_split">
		<div  class="pult_buttons">
		  <a-select class="pult_filter" id='services'></a-select>
		  <a-button id="btn_save" hidden=1 palette="anode-button-active" caption="${$save}"></a-button>
		  <a-button id="btn_cancel" hidden=1 palette="anode-button-empty" caption="${$cancel}"></a-button>
		</div>
	</div>
</div>

<div id="header">
	<div>
	  <div id="title">
		<a-icon id="icon" src="/images/service_disabled.svg"></a-icon>
		<span id="name">...</span>
	  </div>
	  <div id="help"></div>
	  <div id="status">status</div>
	</div>
	<div id="control">
	  <a id="control_link" href="#"><a-icon width="16" src="/images/services.svg"></a-icon> <span>${$control_service}</span></a>
	</div>
  </div>
  <a-form id="form">...</a-form>`,
);

PROPERTIES=[
	{
        key:'service',
        default:'server'
    }
];


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let config;
let schema;
let services;
let service;
let version;
let serverSchema;

let statuses={
    running: $status_running,
    stopped: $status_stopped,
    disabled:$status_disabled,
};


function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/settings'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/settings.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/settings');


    dom.btn_save.onclick=function(){
        dom.form.submit();
    };

    dom.services.onchange=function (e){
        self.service=e.detail;
    }

    

}

function destroy(){

}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='service')		update_service(changes[k]);
	}
}



function update_service(s){
    service=self.__service;
    console.log('update service',service);
    loadConfig();
}


function loadConfig(){

    pult.showLoading(self);

    Util.promises(function (resolve){
        pult.request(self,'system_services',null,function (req,res,err){
            if(err){
                pult.showModalError(self,err);
            }else{
                services=res;
                resolve();                
            }
        });
    },function (resolve){
        pult.request(self,"system_config_schema",{service:'server'},function(req,res,err){ 
            if(err){
                pult.showModalError(self,err);
            }else{
                serverSchema=res;
                resolve();
            }
        });
    },function (resolve){
        pult.request(self,"system_config_schema",{service:service},function(req,res,err){ 
            if(err){
                pult.showModalError(self,err);
            }else{
                schema=res;
                if(schema && schema.CONFIGFACE_APP_INFO) schema.app=schema.CONFIGFACE_APP_INFO;
                if(schema && schema.GATEWAY_SETUP_APP_INFO) schema.app=schema.GATEWAY_SETUP_APP_INFO;
                if(schema && schema.SERVER_APP_INFO) schema.app=schema.SERVER_APP_INFO;
                
                if(schema && schema.CONFIGFACE_APP_INFO) version=2;
                else version=3;
                resolve();
            }
        });
    },function (resolve){
        pult.request(self,"system_config_data",{service:service},function(req,res,err){ 
            if(err){
                pult.showModalError(self,err);
            }else{
                config=res;
                resolve();                
            }
        });
    },function (){
        pult.hideLoading(self);
        showConfig();
    });
}

function ls(str){
    let s;
    try{
        s=JSON.parse(str);
    }catch(e){
        s=str;
    }
    return locale_string(s);
}

function getParamSchema(param){
    let ps;
    ps=schema[param];
    if(!ps){
        for(k in schema){
            if(k.indexOf("*")>=0){
                let r=k.split('*').join('.*');
                if(param.match(r)){
                    ps=schema[k];
                    break;
                }
            }
        }
    }
    if(!ps){
        let schema=serverSchema;
        ps=schema?.[param];
        if(!ps){
            for(k in schema){
                if(k.indexOf("*")>=0){
                    let r=k.split('*').join('.*');
                    if(param.match(r)){
                        ps=schema[k];
                        break;
                    }
                }
            }
        }
    }
    if(!ps) ps={};
    return ps;
}

function getControl(k){

    let sh=getParamSchema(k);
    let v=config[k];
    let c;
    let help=ls(sh.help);
    let at_file=v && v.startsWith('@FILE:');
    
    if(at_file){
        c={
            tag:'a-input',
            width:'100%',
            name:k,
            value:v,
            disabled:1
            //validation:['latinNum','maxLen:64','notEmpty'],
        };
    }else if(sh.control==='select'){
        let lst=[];
        let list=sh.list.split('|');
        for(let i=0; i<list.length; i++){
            let li=list[i];
            let kv=li.split(':');
            if(kv.length===1) kv=[li,li];
            lst.push(kv);
        }
        c={
            tag:'a-select',
            name:k,
            value:v,
            list:lst,
        };
    }else if(sh.control==='checkbox'){
        c={
            tag:'a-label',
            caption: help || ' ',
            html:{
                tag:'a-checkbox',
                name:k,
                value:v,
            }
            //validation:['latinNum','maxLen:64','notEmpty'],
        };
        help=undefined;
    }else if(sh.control==='number'){
        c={
            tag:'a-number',
            name:k,
            value:v,
            width:sh.width,
            //validation:['latinNum','maxLen:64','notEmpty'],
        };
        if(sh.width) c.width=sh.width;
    

    }else{
        c={
            tag:'a-input',
            width:'100%',
            name:k,
            value:v,
            //validation:['latinNum','maxLen:64','notEmpty'],
        };
        if(sh.width) c.width=sh.width;
    }
    c.app_help=help;
    c.sh=sh;
    

    if(k==='enabled' && service==='server'){
        c.disabled=1;
    }

    return c;
}

function getParamList(){
    let params=[];
    if(version===3){
        for(let k in config){
            if(!schema.hidden){
                params.push(k);
            }
        }
    }else if(version===2){
        for(let k in schema){
            if(config[k]!==undefined){
                params.push(k);
            }
        }
        
        for(let k in config){
            if(params.indexOf(k)<0){
                params.push(k);
            }
        }
    }

    let pp=[];
    for(let i=0; i<params.length; i++){
        let p=params[i];
        let sh=getParamSchema(p);
        if(!sh.hidden){
            pp.push({name:p,sort:(sh.sort || 0)*1000+(params.length-i)});
        }
    }
    Util.keySort(pp,'sort',true);
    //console.log(pp);

    params=[];
    for(let i=0; i<pp.length; i++){
        params.push(pp[i]['name']);
    }

    return params;
}


function showConfig(){
    let ss=[];
    for(let i=0; i<services.length; i++){
        ss.push(services[i].name);
    }
    dom.services.list=ss;
    dom.services.value=service;

    dom.name.innerHTML=service;
    dom.control_link.href=`#interface/system?service=${service}`;
    dom.help.innerHTML=schema.app && schema.app.help ? ls(schema.app.help) : '';

    let s=services.find(function (s){if(s.name===service) return s});

    if(s){
        if(s.status==='running') dom.icon.src='/images/service_running.svg';
        if(s.status==='stopped') dom.icon.src='/images/service_stopped.svg';
        if(s.status==='disabled') dom.icon.src='/images/service_disabled.svg';

        if(s.errors){
            let e=pult.errstr({
                code:s.last_error_code,
                message:s.last_error_message,
            });
            dom.title.className='error';
            dom.status.innerHTML=`<error>${$error}: ${e}</error>`;
        }else{
            dom.title.className=s.status;
            dom.status.innerHTML=statuses[s.status];
        }




        dom.form.innerHTML='';
        let fs=[];
        let params=getParamList(s);
    
    
        let main=0;
        for(let i=0; i<params.length; i++){
            let k=params[i];
            let c=getControl(k);
            if(!c.sh.advanced && k!=='enabled'){
                main++;
            }
        }
    
        console.log('main',main);

        if(main){
            fs.push({
                tag:'div',
                class:'confhead',
                html:$main_settings,
            });
            for(let i=0; i<params.length; i++){
                let k=params[i];
                let c=getControl(k);
                if(!c.sh.advanced){
                    fs.push({
                        tag:'a-form-row',
                        caption:k,
                        comment:c.app_help,
                        visibleif:c.sh.visibleif,
                        html:c
                    });
                }
            }
        }
    
        if(main){    
            fs.push({
                tag:'div',
                class:'confhead',
                html:$advanced_settings,
            });
        }
    
        for(let i=0; i<params.length; i++){
            let k=params[i];
            let c=getControl(k);
            if(c.sh.advanced || !main){
                fs.push({
                    tag:'a-form-row',
                    caption:k,
                    comment:c.app_help,
                    visibleif:c.sh.visibleif,
                    html:c
                });
            }
        }
    
        Util.create(dom.form,fs);
    
        dom.form.onchange=function(e){
            pult.needSave=true;
            dom.btn_save.hidden=false;
            dom.btn_cancel.hidden=false;
            dom.services.hidden=true;
        }
    
        dom.form.onsubmit=function(e){
            let cfg=e.detail;
            for(let k in cfg){
                if(cfg[k]===true) cfg[k]=1;
                if(cfg[k]===false) cfg[k]=0;
            }

            let params={};
            params.config={};
            params.config[service]=cfg;
            

            dom.btn_save.submit_start();
    
            pult.request(self,"system_set_config",params,function(req,res,err){
                setTimeout(function(){dom.btn_save.submit_reset()},300);
                if(err){
                    dom.form.reset();
                    showModalError(err);
                }else{
                    dom.form.complete();
                    pult.needSave=false;

                    setTimeout(function(){
                        dom.btn_save.hidden=true;
                        dom.btn_cancel.hidden=true;
                        dom.services.hidden=false;
                    },300);
                }
            });
    
        }
    }

}
