/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Время";
  var $time_comment="Изменение времени применяется только к сервисам данного приложения и&nbsp;не&nbsp;затрагивает системное время на устройстве";
  var $cur_time="Текущее время:";
  var $new_time="Новое время:";
  var $set_new_time="Установить новое время";
  var $time_changed="Время изменено";
}else{
  var $title="Time";
  var $time_comment="Changing the time applies only to the services of this application and does not affect the system time of the device";
  var $cur_time="Current time:";
  var $new_time="New time:";
  var $set_new_time="Set new time";
  var $time_changed="Time changed";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#container{padding:20px}.comment{max-width:500px}a-select{font-size:14px;--select-height:30px;vertical-align:middle;--disabled-text-color:var(--app-text-color);--disabled-border-color:var(--app-control-color)}a-time-picker{font-size:14px;height:30px;vertical-align:middle}`,
	`<div id="container">
    <h3>${$cur_time}</h1>
    <br>
    <a-time-picker id="cur_time" disabled="1" show_clock_button="0"></a-time-picker>&nbsp;<a-select id="cur_zone" disabled="1"></a-select>
    <br>
    <br>
    <a-hr></a-hr>
    <br>
    <h3>${$new_time}</h1>
    <br>
    <a-time-picker id="new_time" show_clock_button="0"></a-time-picker>&nbsp;<a-select id="new_zone"></a-select>
    <br>
    <br>
    <a-button id="btn_set" caption="${$set_new_time}" palette='anode-button-active' ></a-button>
    <br>
    <br>
    <div class="comment">${$time_comment}</div>
    <br>
    <a-hr></a-hr>

  </div>`,
);

ONCREATE=create;
ONDESTROY=destroy;

let int;
let dt=0;
let timestamp=0;


function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/time'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/time.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/time');


    requestTime();

    dom.cur_zone.list=Time.utcZones;
    dom.new_zone.list=Time.utcZones;

    dom.btn_set.onclick=function(){

        let nz=dom.new_zone.value*1;
        let cz=dom.new_time.zone*1;
        let ct=dom.new_time.value;
        let nt=ct + (cz-nz)*3600;

        pult.request(self,"system_set_time",{
            time:nt,
            zone:nz*60,
        },function(req,res,err){
            if(err){
                pult.showModalError(self,err);
            }else{
                window.Time.syncRequest();
                Time.read();
                requestTime();
                pult.showTooltip(self,$time_changed);
            }
        });
    }


    int=setInterval(function(){
        let ts=Time.timestamp-dt;
        if(ts!==timestamp){
            timestamp=ts;
            dom.cur_time.value=timestamp;
        }
    },100);

}


function destroy(){
    clearInterval(int);
}


function requestTime(){
    pult.request(self,"system_time",null,function(req,res,err){
        if(err){
            pult.showError(self,err);
        }else{
            let t=res.time/1000;
            let z=res.zone/60;
            dt=Time.timestamp-t;
            dom.cur_zone.value=z;
            rem_zone=res.zone*60;
           
            dom.cur_time.value=Time.timestamp;
            dom.cur_time.zone=z;

            dom.new_time.value=Time.timestamp;
            dom.new_time.zone=z;

            dom.new_zone.value=z;
        }
    });
}